from handlers.HandlerBase import BaseHandler
from model.log import logger
from data_manage.pitcher_panel import *
log = logger()


class PitcherPanelChannel(BaseHandler):

    def post(self):
        args = self.get_args()
        print(args)
        pitcher = args.get("pitcher", '')
        channel = args.get("channel", '')
        start = args.get("start", du.get_n_days(-1))
        end = args.get("end", du.get_n_days(-1))
        date_range = args.get("date_range", '')
        page = args.get("page",'1')
        page_size = args.get("page_size",'10')
        order_by=args.get("order_by",'date')
        order=args.get("order", 'desc')
        if date_range!='':
            end=du.get_n_days(-1)
            start=du.get_n_days(-int(date_range))

        data=get_pitcher_panel_channel(pitcher, channel, start, end, page, page_size, order_by, order)
        self.write_json(data)


class PitcherPanelDaily(BaseHandler):
    def post(self):
        args=self.get_args()
        pitcher = args.get("pitcher", '')
        start = args.get("start", du.get_n_days(-1))
        end = args.get("end", du.get_n_days(-1))
        date_range = args.get("date_range", '')
        page = args.get("page", '1')
        page_size = args.get("page_size", '10')
        order_by = args.get("order_by", 'date')
        order = args.get("order", 'desc')
        if date_range != '':
            end = du.get_n_days(-1)
            start = du.get_n_days(-int(date_range))

        data = get_pitcher_panel_daily(pitcher, start, end, page, page_size, order_by, order)
        self.write_json(data)


class PitcherPanelOverview(BaseHandler):
    def post(self):
        args=self.get_args()
        pitcher = args.get("pitcher", '')
        data = get_pitcher_panel_overview(pitcher)
        self.write_json(data)


class ChannelOverview(BaseHandler):
    def post(self):
        args=self.get_args()
        print(args)
        channel=args.get("channel",'')
        start=args.get("start",'')
        end=args.get("start",'')
        date_range=args.get("date_range",'')
        page = args.get("page", '1')
        page_size = args.get("page_size", '10')
        order_by = args.get("order_by", 'date')
        order = args.get("order", 'desc')
        if isinstance(date_range,int):
            end = du.get_n_days(-1)
            start = du.get_n_days(-date_range)
        data =get_channel_overview(channel,start,end,page,page_size,order_by,order)
        self.write_json(data)


class ChannelAgainOrderTrend(BaseHandler):
    def post(self):
        args = self.get_args()
        print(args)
        channel = args.get("channel", '')
        date = args.get("date",'')
        data=get_channel_again_order_trend(channel,date)
        self.write_json(data)



class ChannelActive(BaseHandler):
    def post(self):
        args = self.get_args()
        print(args)
        channel = args.get("channel", '')
        start = args.get("start", '')
        end = args.get("start", '')
        date_range = args.get("date_range", '')
        page = args.get("page", '1')
        page_size = args.get("page_size", '10')
        order_by = args.get("order_by", 'date')
        order = args.get("order", 'desc')
        if isinstance(date_range, int):
            end = du.get_n_days(-1)
            start = du.get_n_days(-date_range)
        data=get_channel_active(channel,start,end,page,page_size,order_by,order)
        self.write_json(data)



class ChannelOrderTrend(BaseHandler):
    def post(self):
        arg = self.get_args()
        print(arg)
        channel = arg.get("channel", '')
        start = arg.get("start", '')
        end = arg.get("start", '')
        date_range = arg.get("date_range", '')
        if isinstance(date_range, int):
            end = du.get_n_days(-1)
            start = du.get_n_days(-date_range)
        data=get_channel_order_trend(channel,start,end)
        self.write_json(data)


class ChannelSummary(BaseHandler):
    def post(self):
        arg = self.get_args()
        print(arg)
        channel=arg.get('channel','')
        pitcher=arg.get('pitcher','')

        self.write_json(get_channel_summary(channel,pitcher))





